/* Xscanner : A scanner frontend for Unix written using Xforms.
 * Kees Lemmens; Nov. 1997
 */

#include <stdio.h>
#include <stdlib.h>

#include "forms.h"

#include "xscandefs.h"
#include "twilogo.xpm"
#include "empty.xpm"

FD_Xscanner *fd_Xscanner;
FD_LogView *fd_LogView;
FD_SystemWin *fd_SystemWin;
Xscanrc *info;

void SetFileMenu(FL_OBJECT *ob)
{
   fl_set_menu(ob," Save as Gif | Save as PPM | Save as PS | Exit ");
}

void SetOptionsMenu(FL_OBJECT *ob)
{
   fl_set_menu(ob," Settings | View Log ");
}

void Usage(char *naam)
{
   fprintf(stderr,"\nUsage  : %s [options]\n",naam);
   fprintf(stderr,"Currently no commandline options available\n");
   exit(1);
}

void Initialize(int argc, char *argv[])
{  
   char *basename;
   int x;
   
   basename=argv[0];
   
   x=argc;
   while(--x>0)                    /* parse options */
   {
      if(*argv[1]=='-')
      {
	 switch(*(++argv[1]))
	 {
	  default:  Usage(basename); break;
	 }
	 ++argv; --argc;
      }
   }
   
   fl_set_goodies_font(FL_NORMAL_STYLE,14); /* a little bigger ! */
   fl_setpup_fontsize(14);

   fl_set_pixmap_data(fd_Xscanner->Logo,twilogo);
   
   fl_addto_choice(fd_Xscanner->Format,info->Formats);
   fl_set_choice_fontsize(fd_Xscanner->Format,12);
   fl_set_choice_fontstyle(fd_Xscanner->Format,FL_BOLD_STYLE);

   fl_set_slider_step(fd_Xscanner->Resolution,5.0);
   fl_set_slider_step(fd_Xscanner->Contrast,0.02);
   fl_set_slider_step(fd_Xscanner->Brightness,0.02);

   fl_set_button(fd_Xscanner->FullSize,1);
   fl_hide_object(fd_Xscanner->SubAreaBox);
   fl_hide_object(fd_Xscanner->Crosshair);
   
   SetFileMenu(fd_Xscanner->FileMenu);
   SetOptionsMenu(fd_Xscanner->OptionsMenu);
   
   fl_set_pixmap_data(fd_Xscanner->PreviewArea,empty);
   // just to remove the stupid "p" from the center when empty

#ifndef DEBUG   
   RedirectIO(stderr);
   RedirectIO(stdout);
#endif

   fl_show_form(fd_LogView->LogView,
		FL_PLACE_FREE,FL_FULLBORDER,"LogView");
}

int main(int argc, char *argv[])
{
   fl_initialize(&argc, argv, 0, 0, 0);

   fd_Xscanner = create_form_Xscanner();
   fd_LogView = create_form_LogView();
   fd_SystemWin = create_form_SystemWin();
      
   info = LoadUserInfo();
   
   Initialize(argc,argv);

   /* show the first form */
   fl_show_form(fd_Xscanner->Xscanner,FL_PLACE_CENTER,
		FL_FULLBORDER,"Xscanner");
   while(1)
     fl_do_forms();
   return 0;
}
